/******************************************************************************
 * Icinga 2                                                                   *
 * Copyright (C) 2012 Icinga Development Team (http://www.icinga.org/)        *
 *                                                                            *
 * This program is free software; you can redistribute it and/or              *
 * modify it under the terms of the GNU General Public License                *
 * as published by the Free Software Foundation; either version 2             *
 * of the License, or (at your option) any later version.                     *
 *                                                                            *
 * This program is distributed in the hope that it will be useful,            *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of             *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *
 * GNU General Public License for more details.                               *
 *                                                                            *
 * You should have received a copy of the GNU General Public License          *
 * along with this program; if not, write to the Free Software Foundation     *
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.             *
 ******************************************************************************/

#ifndef NOTIFICATIONCOMPONENT_H
#define NOTIFICATIONCOMPONENT_H

#include "remoting/endpoint.h"
#include "base/dynamicobject.h"
#include "base/timer.h"

namespace icinga
{

/**
 * @ingroup notification
 */
class NotificationComponent : public DynamicObject
{
public:
	NotificationComponent(const Dictionary::Ptr& serializedUpdate);

	virtual void Start(void);
	virtual void Stop(void);

private:
	Timer::Ptr m_NotificationTimer;
	Endpoint::Ptr m_Endpoint;

	void NotificationTimerHandler(void);
	void SendNotificationsRequestHandler(const Endpoint::Ptr& sender, const RequestMessage& request);
};

}

#endif /* NOTIFICATIONCOMPONENT_H */
